define(['underscore', 'backbone', 'handlebars', 'context'], function (_, Backbone, Handlebars, Context) {
    var Condition = Backbone.Model.extend({
        defaults: {
            column: "",
            operator: "=",
            value: "",
            q: Context.quoteChar()
        },
        isOpNully: function () {
          var op = this.get("operator").toLowerCase();
          return op && _.indexOf(["is null", "is not null"], op) > -1;
        },
        queryString: function () {
            var tpl;
            this.set("q", Context.quoteChar());
            if (this.isOpNully()) {
                tpl = Handlebars.compile("{{{ q }}}{{{ column }}}{{{ q }}} {{{ operator }}}");
            } else {
                tpl = Handlebars.compile("{{{ q }}}{{{ column }}}{{{ q }}} {{{ operator }}} ?");
            }
            return tpl(this.toJSON());
        }
    });
    return Condition;
});
