define(['context', 'views/sidebar', 'jquery', 'models/connection', 'backbone'],
    function (Context, SidebarView, $, Connection, Backbone) {
        describe("SidebarView", function () {

            // disable ajax
            Backbone.ajax = function () {};

            var c1 = new Connection({id: 1, title: "Test Connection", port: 3306, username: "foo", hostname: "localhost"});
            var view = new SidebarView();
            var r = view.render({connection: c1.toJSON()});

            it("should set connection title", function () {
                var title = $(r.el).find(".connection-title").text().trim();
                expect(title).toEqual("foo@localhost:3306");
            });
            it("should have list headings", function () {
                expect($(r.el).find(".tables li.heading").length).toEqual(2);
            });
            it("should have db switcher", function () {
                expect($(r.el).find(".db-switcher select.active-db").length).toEqual(1);
            });
        });
    });