define(["jquery", "underscore", "backbone", "tpls", "views/builder/structure", "views/builder/indexes",
    "views/builder/foreign"], function ($, _, Backbone, Templates, StructureMode, IndexesMode, ForeignKeysMode) {
    return Backbone.View.extend({
        template: Templates["builder/body"],
        subviews: {},
        events: {
            "click .builder-menu .btn": "activateMode"
        },
        initialize: function () {
            this.subviews["StructureMode"] = new StructureMode();
            this.subviews["IndexesMode"] = new IndexesMode();
            this.subviews["ForeignKeysMode"] = new ForeignKeysMode();
            return this;
        },
        activateMode: function (e) {
            var mode;
            $(e.target).addClass("btn-primary").siblings().removeClass("btn-primary");
            mode = $(e.target).data("mode") + "Mode";
            this.renderSubView(mode);
            return this;
        },
        renderSubView: function (name) {
            if (name in this.subviews) {
                console.log("render builder subview:", name);
                this.$(".builder-content").html(this.subviews[name].render().el);
            } else {
                console.warn("builder subview not found");
            }
            return this;
        },
        render: function () {
            this.$el.html(this.template());
            this.renderSubView("StructureMode");
            return this;
        }
    });
});
